import { ProgressValue } from '@polkadot/db/types';
import { DbConfig$Type } from '../types';
export declare type MessageTypeRead = 'get' | 'getRoot' | 'hasRoot';
export declare type MessageTypeWrite = '__init' | 'checkpoint' | 'commit' | 'del' | 'put' | 'revert' | 'setRoot';
export declare type MessageType = MessageTypeRead | MessageTypeWrite;
export declare type MessageData = {
    buffer: Uint8Array;
    key?: Uint8Array;
    port?: WorkerThreads.MessagePort;
    value?: Uint8Array;
};
export declare type Message = MessageData & {
    state: Int32Array;
    type: MessageType;
};
export declare type WorkerData = {
    isTrie: boolean;
    path: string;
    type: DbConfig$Type;
};
export declare type ProgressMessage = {
    isCompleted: boolean;
    progress: ProgressValue;
};
