"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _createFunction = _interopRequireDefault(require("@polkadot/storage/utils/createFunction"));

var _Modules = require("@polkadot/types/Metadata/Modules");

var _Text = _interopRequireDefault(require("@polkadot/types/Text"));

var _Vector = _interopRequireDefault(require("@polkadot/types/codec/Vector"));

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
// Small helper function to factorize code on this page.
const createMethod = (method, key, _ref) => {
  let documentation = _ref.documentation,
      isMap = _ref.isMap,
      type = _ref.type;
  return (0, _createFunction.default)(new _Text.default('Block'), new _Text.default(key), {
    documentation: new _Vector.default(_Text.default, documentation),
    modifier: new _Modules.StorageFunctionModifier(0),
    type: new _Modules.StorageFunctionType(type, isMap ? 1 : 0),
    toJSON: () => key
  }, {
    isUnhashed: false,
    method
  });
};

var _default = {
  bestHash: createMethod('bestHash', 'bst:hsh', {
    documentation: ['Best hash'],
    type: 'Hash'
  }),
  bestNumber: createMethod('bestNumber', 'bst:num', {
    documentation: ['Best block'],
    type: 'BlockNumber'
  }),
  blockByHash: createMethod('blockByHash', 'blk:hsh:', {
    documentation: ['Retrieve block by hash'],
    type: {
      key: 'Hash',
      value: 'Bytes'
    }
  }),
  headerByHash: createMethod('headerByHash', 'hdr:hsh:', {
    documentation: ['Retrieve header by hash'],
    type: {
      key: 'Hash',
      value: 'Bytes'
    }
  })
};
exports.default = _default;