"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeArrayU8a;

var _util = require("@polkadot/util");

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function decodeArrayU8a(db, createKey) {
  return {
    del: function del() {
      for (var _len = arguments.length, keyParams = new Array(_len), _key = 0; _key < _len; _key++) {
        keyParams[_key] = arguments[_key];
      }

      return db.del(createKey(keyParams));
    },
    get: function get() {
      for (var _len2 = arguments.length, keyParams = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        keyParams[_key2] = arguments[_key2];
      }

      const u8a = db.get(createKey(keyParams));

      if (u8a === null) {
        return [];
      }

      const length = (0, _util.u8aToBn)(u8a.subarray(0, 4), true).toNumber();
      const result = [];
      let offset = 4;

      for (let index = 0; index < length; index++, offset += 32) {
        result.push(u8a.subarray(offset, offset + 32));
      }

      return result;
    },
    set: function set(value) {
      for (var _len3 = arguments.length, keyParams = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        keyParams[_key3 - 1] = arguments[_key3];
      }

      return db.put(createKey(keyParams), (0, _util.u8aConcat)((0, _util.bnToU8a)(value.length, 32, true), _util.u8aConcat.apply(null, value)));
    },
    onUpdate: updater => {
      throw new Error(`No subscriber available for db/arrayU8a`);
    }
  };
}