"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeU8a;

var _base = _interopRequireDefault(require("./base"));

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function decodeU8a(db, createKey) {
  const base = (0, _base.default)(db);
  return {
    del: function del() {
      for (var _len = arguments.length, keyParams = new Array(_len), _key = 0; _key < _len; _key++) {
        keyParams[_key] = arguments[_key];
      }

      return base.del(createKey(keyParams));
    },
    get: function get() {
      for (var _len2 = arguments.length, keyParams = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        keyParams[_key2] = arguments[_key2];
      }

      return base.get(createKey(keyParams));
    },
    set: function set(value) {
      for (var _len3 = arguments.length, keyParams = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        keyParams[_key3 - 1] = arguments[_key3];
      }

      return base.set(createKey(keyParams), value, value);
    },
    onUpdate: updater => base.onUpdate(updater)
  };
}